#ifndef TADGRAFO_H_
#define TADGRAFO_H_

typedef int IdVertice;

#include "TadListaAresta.h"
#include "TadListaVertice.h"

// definies para tratamento de erros
#define OK 0  //define que no houve erros
#define ERRVERTICEINEXISTENTE 1 
//defina aqui outros tipos de erros se necessrio

typedef int codErro; //identificao de erros
typedef void* TipoItem;

typedef struct {
	IdVertice Id;
	TipoItem Item;
	TadListaAresta* listadearestas; // um vrtice contm uma lista de arestas
} Vertice; 

typedef struct {
	IdVertice IdDestino;	// destino da aresta
	Vertice* Destino;	// informao adicional (ponteiro para Vertice)
} Aresta; 

typedef TadListaVertice TadGrafo;	// um grafo  representado como uma lista de vrtices

TadGrafo* CriaGrafo ();
int EstaVazio (TadGrafo* g);
IdVertice IncluiVertice (TadGrafo* g , TipoItem item);
codErro ExcluiVertice (TadGrafo* g,  IdVertice id);
codErro ConectaVertices (TadGrafo* g, IdVertice id1, IdVertice id2);
TadListaVertice* RetornaListaVertices(TadGrafo* g);  
TadListaAresta* RetornaListaArestas (TadGrafo* g, IdVertice id); 
int EstaConectado (TadGrafo* g, IdVertice id1, IdVertice id2);
int Alcancavel (TadGrafo* g, IdVertice id1, IdVertice id2);
void DestroiGrafo(TadGrafo* g);


#endif /*TADGRAFO_H_*/
